
'Frequenzeingabe ber Tastertur fr FT 100
'Peter Horlacher DH1PAX
'13.03.2004

' Compilerparameter fr BASCOM

$baud = 4800                                                'Baudrate
$crystal = 4915200                                          'Quarzfrequenz

' Variablendeklaration

Dim A As Byte , I As Byte , D As Byte , E As Byte , F As Byte
Dim G As Word                                         'Frequenz, 4 Stellen
Dim S As Byte                                         'Simplexflag
Dim C(16) As Byte                                     'Array fr Tastaturtabelle
Dim K(10) As Byte                                     'Array fr Frequenz
Dim Aohne(5) As Byte                                  'ohne Ablage
Dim Aneg(5) As Byte                                   'negativer Offset
'Dim A2m(5) As Byte                                   'Ablage 2m (nur FT-817)
'Dim A70cm(5) As Byte                                 'Ablage 70cm (nur FT-817)
'Dim A10m(5) As Byte                                  'Ablage 10m (nur FT-817)

' BASCOM verlangt Deklaration aller Unterprogramme im Kopfteil,
' ihre Definition erfolgt weiter unten
Declare Sub Zero_freq()                               'Frequenz lschen
Declare Sub Check2m()                                 'Relaisablage 2m prfen
Declare Sub Check70cm()                               'dito, 70cm
Declare Sub Check10m()                                'dito, 10m


' Definition der Umwandlungstabelle fr die Scancodes der Tastaturmatrix
' in den Zahlenwert der Taste (mittels Arrayvariable C)
C(1) = 1
C(2) = 2
C(3) = 3
Rem c(4) = 'a'                                        'Bei Matrix 4*4 vierte Spalte
C(5) = 4
C(6) = 5
C(7) = 6
Rem c(8) = 'b'                                        'dito, noch unbenutzt
C(9) = 7
C(10) = 8
C(11) = 9
Rem c(12) = 'c'                                       'dito
C(13) = 12
C(14) = 0
C(15) = 14
Rem c(16) ='d'                                        'dito


' Array K initialisieren, mit Frequenz 00 00 00 00:
Call Zero_freq
' und mit Befehlswort zum Setzen der Frequenz:
'K(5) = &H01                   'Befehlswort 01 bedeutet Frequenz setzen (FT-817)
K(5) = &H0A                    'anderer Code fr FT-100 zum Setzen der Frequenz


' Definition der Arrays mit Befehlsfolgen zur Wahl von Simplexbetrieb
' und ggf. erforderlicher Shift bei Relaisfrequenzen

                    ' simplex
'Aohne(1) = &H89                                            ' FT-817
'Aohne(2) = &H00
'Aohne(3) = &H00
'Aohne(4) = &H00
'Aohne(5) = &H09

Aohne(1) = &H00                                             ' FT-100
Aohne(2) = &H00
Aohne(3) = &H00
Aohne(4) = &H00
Aohne(5) = &H84

                     ' duplex negativer offset
'Aneg(1) = &H09                                             ' FT-817
'Aneg(2) = &H00
'Aneg(3) = &H00
'Aneg(4) = &H00
'Aneg(5) = &H09

Aneg(1) = &H00                                              ' FT-100
Aneg(2) = &H00
Aneg(3) = &H00
Aneg(4) = &H01
Aneg(5) = &H84

'Beim FT-100 kann der Wert des Frequenzversatzes nicht ber die CAT-
'Schnittstelle bertragen werden, auswahl erfolgt im Gert automatisch.

                     ' Ablage Duplex auf 2m: 600kHz
'A2m(1) = &H00                                              ' nur FT-817
'A2m(2) = &H06
'A2m(3) = &H00
'A2m(4) = &H00
'A2m(5) = &HF9

                    ' Ablage Duplex auf 70cm: 7,6 MHz
'A70cm(1) = &H00                                            'nur FT-817
'A70cm(2) = &H76
'A70cm(3) = &H00
'A70cm(4) = &H00
'A70cm(5) = &HF9

                    ' Ablage Duplex auf 10m 100kHz
'A10m(1) = &H00                                             'nur FT-817
'A10m(2) = &H01
'A10m(3) = &H00
'A10m(4) = &H00
'A10m(5) = &HF9


' hier wird die Untersttzung fr Matrixtastaturen des BASCOM-Compilers
' deklariert: Tastatur an Portb mit 100ms delay
Config Kbd = Portb , Delay = 100


I = 0               ' Zeichenpuffer ist bei Programmstart noch leer


' Hauptprogramm:

Tast:                        'Hauptschleife, wird ab hier endlos durchlaufen

Do                           'Tastaturabfrage: wartet auf Tastendruck
A = Getkbd()                 'liefert Wert 0-16, blockiert nicht
Loop Until A <> 16           '16 bedeutet keine Taste gedrckt, Warteschleife

Do                           'wartet, bis Taste losgelassen wird
D = Getkbd()
Loop Until D = 16

I = I + 1                    'Zeichenzhler erhhen
A = C(a + 1)                 'Scancode der Tastaturmatrix nach Ziffer wandeln

If A > 9 Then Goto Ausgabe   'nur Ziffern speichern, sonst berspringen

D = I Mod 2                  'wenn i gerade, dann d=0, sonst d=1
E = I \ 2                    'ganzzahlige Division ohne Rest , z.B. 3\2 ergibt 1
E = E + D                    'Index fr Tastaturarray
'F=E                         'nur fr FT-817 verwenden,
F = 5 - E                    'sonst diese nderung fr FT-100

If D = 1 Then                'nur fuer ungerade I
 Shift A , Left , 4          'untere 4 Bit in die oberen 4 Bit schieben
 K(f) = A And &HF0           'obere 4 Bit maskieren und im Frequenzstring merken
Else                         'nur fuer gerade I
 A = A And &H0F              'nur untere 4 Bit maskieren
 K(f) = K(f) + A             'und zum Frequenzstring dazuaddieren
End If


Ausgabe:

If A = 12 Then               'unbelegte Taste, hier wurde '*' gedrckt
'Programmerweiterungen, etwa Auswertung der '*'-Taste oder einer geren
'Tastaturmatrix, knnen ab hier erfolgen.
 I = I - 1                   'da I schon erhht wurde, dies zurcknehmen
End If                       '*' wirkt also wie gar kein Tastendruck)

If I = 8 Or A = 14 Then      '8 Stellen eingegeben oder Raute gedrckt

 Printbin K(1) ; 5           'Frequenz ber serielles Interface im FT-100 setzen
 Waitms 200                  'kurze Zwangspause
 S = 1                       'Flag: Betrieb ohne Ablage als Default merken


' Ggf. Shift ermitteln und setzen (FT-817)
' G = K(2)                   '6. und 5. Stelle der Frequenz in k(2)
' Shift G , Left , 8         'in die oberen 8 Bit der 16 Bit-Variable G schieben
' G = G + K(3)               'und 4. und 3. Stelle in die unteren 8 Bit:
' ergibt also eine Variable mit 1MHz-, 100kHz-, 10kHz-, 1kHz-Werten der Frequenz
' fr weiteren Vergleich
' Select Case K(1)           'erste beide Stellen der Frequenz in Byte k(1)


'Ggf. Shift ermitteln und setzen (FT-100)
 G = K(3)                    '6. und 5. Stelle der Frequenz in k(3)
 Shift G , Left , 8          'in die oberen 8 Bit der 16 Bit-Variable G schieben
 G = G + K(2)                'und 4. und 3. Stelle in die unteren 8 Bit:
'ergibt also eine Variable mit 1MHz-, 100kHz-, 10kHz-, 1kHz-Werten der Frequenz
'fr weiteren Vergleich
 Select Case K(4)            'erste beide Stellen der Frequenz in Byte k(4)
  Case &H14 : Call Check2m   '2m-Relaisfrequenz? Prfung in Check2m
  Case &H43 : Call Check70cm '70cm-Relaisfrequenz? Prfung in Check70cm
  Case &H02 : Call Check10m  '10m-Relaisfrequenz? Prfung in Check10m
 End Select

 If S = 1 Then               'falls Simplexbetrieb,
  Printbin Aohne(1) ; 5      'diesen auswaehlen
  Waitms 200
 End If

 Call Zero_freq              'alte Frequenz lschen
 I = 0                       'es sind also bislang 0 Stellen eingegeben

End If
Goto Tast                    'Endlosschleife mittels Rcksprung schlieen


' Unterprogrammdefinitionen stehen ab hier:


Sub Zero_freq()         'die vier Bytes zur Aufnahme der Frequenz auf 00 setzen
 K(1) = 0
 K(2) = 0
 K(3) = 0
 K(4) = 0
End Sub



Rem auf 2m 145,600 MHz. bis 145,800 MHz. wird 0,6 MHz. tiefer gesendet

Sub Check2m()
  If G >= &H5600 And G <= &H5800 Then            '145,600 MHz - 145,800 MHz
'   Printbin A2m(1) ; 5                          'Frequenz -00,600000 MHz
'   Waitms 200
   Printbin Aneg(1) ; 5                          'Ablage neg. shift
   Waitms 200
   S = 0                                         'Duplexbetrieb gesetzt Flag
  End If
End Sub



Rem auf 70cm 438,650 MHz. bis 439,425 MHz. wird 7,6 MHz. tiefer gesendet

Sub Check70cm
  If G >= &H8650 And G < &H9425 Then             '438,650 MHz - 439,425 MHz
'   Printbin A70cm(1) ; 5
'   Waitms 200
   Printbin Aneg(1) ; 5                          'Ablage neg. shift
   Waitms 200
   S = 0                                         'Duplexbetrieb gesetzt Flag
  End If
End Sub



Rem auf 10m 29,660 MHz. bis 29,690 MHz. wird 0,1 MHz. tiefer gesendet

Sub Check10m()
  If G >= &H9660 And G <= &H9690 Then            '29,660 MHz - 29,690 MHz
'   Printbin A10m(1) ; 5                         'Frequenz -00,100000 MHz
'   Waitms 200
   Printbin Aneg(1) ; 5                          'Ablage neg. shift
   Waitms 200
   S = 0                                         'Duplexbetrieb gesetzt Flag
  End If
End Sub



' E N D E